您的位置:首页 > 其它

HDU 1025(最长上升子序列)

2018-02-23 13:59 330 查看

Constructing Roads In JGShining’s Kingdom

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Problem Description

JGShining’s kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.

Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource. You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.

With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they’re unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor cities don’t wanna build a road with other poor ones, and rich ones also can’t abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.

Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.

The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities … And so as the poor ones.

But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.

For example, the roads in Figure I are forbidden.



In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^_^

Input

Each test case will begin with a line containing an integer n(1 ≤ n ≤ 500,000). Then n lines follow. Each line contains two integers p and r which represents that Poor City p needs to import resources from Rich City r. Process to the end of file.

Output

For each test case, output the result in the form of sample.

You should tell JGShining what’s the maximal number of road(s) can be built.

Sample Input

2

1 2

2 1

3

1 2

2 3

3 1

Sample Output

Case 1:

My king, at most 1 roa
c84e
d can be built.

Case 2:

My king, at most 2 roads can be built.

Hint

Huge input, scanf is recommended.

问题分析

题意:现在有2*n个城市,一半为富裕城市,一半为贫困城市。每一个富裕城市都在某个东西上很富裕,每一个贫困城市又恰好都在每个富裕城市所富裕的东西上很稀缺,所以他们就要修路让富裕城市所富裕的东西分享给那个恰好稀缺的贫困城市。但是,为了不产生交通问题,各个路不能交叉。

所以…啰嗦了这么多,这道题其实就是一道最长上升子序列的题。

首先,我们如果把它当做dp来做。

肯定是会超时的,因为数据达到了50w,用O(n^2)方法肯定过不了的。

所以我们何不将最长上升子序列放入到一个数组里面呢,每轮到一个元素,如果它比当前最长上升子序列的最后一个元素大,就将其放入末尾;否则就在当前最长子序列里用二分查找,找到第一个大于等于它的位置,将其放入。这样算下来,遍历一遍所有元素用O(n)就可以,而二分查找则是O(log(n)),所以总的时间复杂度为O(n*log(n)),这样就不会超时啦~。

好,上AC code(^_^)~

#include<stdio.h>
#include<iostream>
#include<algorithm>
#include<string.h>
#define N 500001
using namespace std;

int a
,dp
;

int binary(int l, int r, int num)
{
r--;
while(l<=r)
{
int mid = l-(l-r)/2;
if(dp[mid]==num)
return mid;
else if(dp[mid]>num)
r = mid-1;
else if(dp[mid]<num)
l = mid+1;
}
return l;
}

int main()
{
int n,t = 1;
// freopen("in.txt","r",stdin);
while(~scanf("%d",&n))
{
for(int i = 0; i < n; i++)
{
int p,r;
scanf("%d%d",&p,&r);
a[p] = r;
}
int j = 1;
dp[0] = a[1];
for(int i = 2; i <= n; i++)
{
if(a[i]>dp[j-1])//如果比当前最长上升子序列的末尾元素大
dp[j++] = a[i];
else
{
int index = binary(0,j,a[i]);//否则将其放入当前最长上升子序列里的一个合适位置
dp[index] = a[i];
}
}
if(j==1)//表示此处是坑点啊QAQ
cout<<"Case "<<t++<<":\nMy king, at most "<<j<<" road can be built.\n"<<endl;
else
cout<<"Case "<<t++<<":\nMy king, at most "<<j<<" roads can be built.\n"<<endl;
}

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: